; ==================================================================================================
; Title:   MSChart.inc
; Author:  G. Friedrich
; Version: 1.0.0
; Purpose: MSChart Host using ObjAsm32.
; Notes:   Version 1.0.0, March 2009
;            - First release.
; ==================================================================================================

; Links:
; 
;http://msdn.microsoft.com/en-us/library/3ks53324(VS.71).aspx     MSChart control reference
;http://groups.google.com/group/comp.os.ms-windows.programmer.win32/msg/09b3e44b5eca25a6
;ATL71.DLL is distributed with the free .NET Framework 1.1.
;There is available a redistributable package:
;Microsoft .NET Framework Version 1.1 Redistributable Package
;http://www.microsoft.com/downloads/details.aspx?FamilyId=262D25E3- F589-4842-8157-034D1E7CF3A3&displaylang=en
;http://msdn.microsoft.com/en-us/library/ms692780(VS.85).aspx     COM ActiveX container
;http://www.developersdex.com/vb/message.asp?p=640&r=6546867      Bug report
;http://msdn.microsoft.com/de-de/library/bb979332.aspx
;C:\WINDOWS\HELP\MSCHRT98.chm                                     Help file
;http://msdn.microsoft.com/en-us/vbrun/ms788708.aspx              MS support commitment for Win7
;http://www.microsoft.com/downloads/details.aspx?familyid=CB824E35-0403-45C4-9E41-459F0EB89E36&displaylang=en
;http://support.microsoft.com/kb/194784                           Controls shipped with VB6.0
;regsvr32 c:\windows\system32\mschrt20.ocx


; ==================================================================================================
;     Object definitions
; ==================================================================================================


MSC_INIT_FAILED   equ   1

Object MSChart,, WinPrimer
  RedefineMethod    Done
  RedefineMethod    Init,             Pointer

  DefineVariable    pIChart,          Pointer,  NULL
  DefineVariable    pIOleObject,      Pointer,  NULL
  DefineVariable    hATL71Dll,        Pointer,  NULL
  DefineVariable    pChartSink,       Pointer,  NULL
  DefineVariable    pIChartEvents,    Pointer,  NULL
  DefineVariable    pIEventsCP,       Pointer,  NULL
  DefineVariable    dEventsCookie,    dword,    0
ObjectEnd


Object IMSChartEvents,, IDispatch
  RedefineMethod   DispatchInvoke,    dword, Pointer, dword, word, LPDISPPARAMS, Pointer, \
                                           Pointer, Pointer
	Event   OLEStartDrag,         00000060Eh
	Event   OLEGiveFeedback,      00000060Fh
	Event   OLESetData,           000000610h
	Event   OLECompleteDrag,      000000611h
	Event   OLEDragOver,          000000612h
	Event   OLEDragDrop,          000000613h
	Event   ChartSelected,        000000001h
	Event   TitleSelected,        000000002h
	Event   FootnoteSelected,     000000003h
	Event   LegendSelected,       000000004h
	Event   PlotSelected,         000000005h
	Event   AxisSelected,         000000006h
	Event   AxisLabelSelected,    000000007h
	Event   AxisTitleSelected,    000000008h
	Event   PointSelected,        000000009h
	Event   PointLabelSelected,   00000000Ah
	Event   SeriesSelected,       00000000Bh
	Event   ChartActivated,       00000000Dh
	Event   TitleActivated,       00000000Eh
	Event   FootnoteActivated,    00000000Fh
	Event   LegendActivated,      000000010h
	Event   PlotActivated,        000000011h
	Event   AxisActivated,        000000012h
	Event   AxisLabelActivated,   000000013h
	Event   AxisTitleActivated,   000000014h
	Event   PointActivated,       000000015h
	Event   PointLabelActivated,  000000016h
	Event   SeriesActivated,      000000017h
	Event   AxisUpdated,          00000001Ah
	Event   AxisLabelUpdated,     00000001Bh
	Event   AxisTitleUpdated,     00000001Ch
	Event   ChartUpdated,         00000001Dh
	Event   FootnoteUpdated,      00000001Eh
	Event   LegendUpdated,        00000001Fh
	Event   PlotUpdated,          000000020h
	Event   PointUpdated,         000000021h
	Event   PointLabelUpdated,    000000022h
	Event   SeriesUpdated,        000000023h
	Event   TitleUpdated,         000000025h
	Event   DataUpdated,          000000026h
	Event   DonePainting,         000000027h
	Event   Click,                0FFFFFDA8h
	Event   DblClick,             0FFFFFDA7h
	Event   KeyDown,              0FFFFFDA6h
	Event   KeyPress,             0FFFFFDA5h
	Event   KeyUp,                0FFFFFDA4h
	Event   MouseDown,            0FFFFFDA3h
	Event   MouseMove,            0FFFFFDA2h
	Event   MouseUp,              0FFFFFDA1h

  VirtualMethod  OLEStartDrag,        ptr ptr DataObject, ptr sdword
  VirtualMethod  OLEGiveFeedback,     ptr sdword, ptr BOOL
  VirtualMethod  OLESetData,          ptr ptr DataObject, ptr sword
  VirtualMethod  OLECompleteDrag,     ptr sdword
  VirtualMethod  OLEDragOver,         ptr ptr DataObject, ptr sdword, ptr sword, ptr sword, ptr real4, ptr real4, ptr sword
  VirtualMethod  OLEDragDrop,         ptr ptr DataObject, ptr sdword, ptr sword, ptr sword, ptr real4, ptr real4
  VirtualMethod  ChartSelected,       ptr sword, ptr sword
  VirtualMethod  TitleSelected,       ptr sword, ptr sword
  VirtualMethod  FootnoteSelected,    ptr sword, ptr sword
  VirtualMethod  LegendSelected,      ptr sword, ptr sword
  VirtualMethod  PlotSelected,        ptr sword, ptr sword
  VirtualMethod  AxisSelected,        ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  AxisLabelSelected,   ptr sword, ptr sword, ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  AxisTitleSelected,   ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  PointSelected,       ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  PointLabelSelected,  ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  SeriesSelected,      ptr sword, ptr sword, ptr sword
  VirtualMethod  ChartActivated,      ptr sword, ptr sword
  VirtualMethod  TitleActivated,      ptr sword, ptr sword
  VirtualMethod  FootnoteActivated,   ptr sword, ptr sword
  VirtualMethod  LegendActivated,     ptr sword, ptr sword
  VirtualMethod  PlotActivated,       ptr sword, ptr sword
  VirtualMethod  AxisActivated,       ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  AxisLabelActivated,  ptr sword, ptr sword, ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  AxisTitleActivated,  ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  PointActivated,      ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  PointLabelActivated, ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  SeriesActivated,     ptr sword, ptr sword, ptr sword
  VirtualMethod  AxisUpdated,         ptr sword, ptr sword, ptr sword
  VirtualMethod  AxisLabelUpdated,    ptr sword, ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  AxisTitleUpdated,    ptr sword, ptr sword, ptr sword
  VirtualMethod  ChartUpdated,        ptr sword
  VirtualMethod  FootnoteUpdated,     ptr sword
  VirtualMethod  LegendUpdated,       ptr sword
  VirtualMethod  PlotUpdated,         ptr sword
  VirtualMethod  PointUpdated,        ptr sword, ptr sword, ptr sword
  VirtualMethod  PointLabelUpdated,   ptr sword, ptr sword, ptr sword
  VirtualMethod  SeriesUpdated,       ptr sword, ptr sword
  VirtualMethod  TitleUpdated,        ptr sword
  VirtualMethod  DataUpdated,         ptr sword, ptr sword, ptr sword, ptr sword, ptr sword, ptr sword
  VirtualMethod  DonePainting
  VirtualMethod  Click
  VirtualMethod  DblClick
  VirtualMethod  KeyDown,             ptr sword,sword
  VirtualMethod  KeyPress,            ptr sword
  VirtualMethod  KeyUp,               ptr sword,sword
  VirtualMethod  MouseDown,           sword, sword, OLE_XPOS_PIXELS, OLE_YPOS_PIXELS
  VirtualMethod  MouseMove,           sword, sword, OLE_XPOS_PIXELS, OLE_YPOS_PIXELS
  VirtualMethod  MouseUp,             sword, sword, OLE_XPOS_PIXELS, OLE_YPOS_PIXELS

  RedefineMethod    Init,             Pointer
ObjectEnd



.code

if IMPLEMENT


; ==================================================================================================
;     MSChart implementation
; ==================================================================================================

; 
; Method:    MSChart.Done
; Purpose:   Finalizes the Host object.
; Arguments: None.
; Return:    Nothing.

Method MSChart.Done, uses esi
    SetObject esi
    .if [esi].pIEventsCP != NULL
      ICall [esi].pIEventsCP::IConnectionPoint.Unadvise, [esi].dEventsCookie
    .endif
    SAFE_RELEASE_AND_NULLIFY [esi].pIOleObject
    SAFE_RELEASE_AND_NULLIFY [esi].pIChart
    invoke FreeLibrary, [esi].hATL71Dll
    ACall esi.Done
MethodEnd

; 
; Method:    MSChart.Init
; Purpose:   Initializes the Host object and creates an Excel Application instance.
; Arguments: -> Owner.
; Return:    OBJ_OK if succeeded.

Method MSChart.Init, uses esi, pOwner:Pointer
    local ClsID:GUID, pIUnknown:Pointer, wszCLSID[128]:word
    local pICPC:Pointer

    SetObject esi
    ACall esi.Init, pOwner, NULL

    invoke LoadLibrary, $OfsCStr("atl71.dll")     ;.NET distro 1.1
    .if eax != NULL
      mov [esi].hATL71Dll, eax
      invoke CLSIDFromProgID, $OfsCUStr("MSChart20Lib.MSChart.2"), addr ClsID
      .if SUCCEEDED(eax)
        invoke StringFromGUID2, addr ClsID, addr wszCLSID, sizeof wszCLSID

        call $invoke(GetProcAddress, [esi].hATL71Dll, $OfsCStr("AtlAxWinInit"))
        mov edx, [esi].pOwner
        ;The trick here is to pass the ClassID in form of a string as the title parameter
        invoke CreateWindowExW, 0, $OfsCUStr("AtlAxWin71"), addr wszCLSID, \
                               WS_CHILD or WS_VISIBLE, 0,0,0,0, \
                               [edx].WinPrimer.hWnd, 0, hInstance, 0
        .if eax != 0
          mov [esi].hWnd, eax
          and pIUnknown, NULL
          lea eax, pIUnknown
          push eax
          push [esi].hWnd
          call $invoke(GetProcAddress, [esi].hATL71Dll, $OfsCStr("AtlAxGetControl"))
          .if SUCCEEDED(eax)
            ICall pIUnknown::IUnknown.QueryInterface, offset IID__DMSChart, addr [esi].pIChart

            ;Now we need to create the event sink object to get notifications from the chart
            mov [esi].pIChartEvents, $New(IMSChartEvents)
            push eax
            mov [esi].pChartSink, $New(Component, Init, esi, NULL)
            OCall [eax].Component.pInterfaces::Collection.Insert, /eax
            lea ecx, [esi].dEventsCookie
            push ecx
            push eax
            OCall eax::IMSChartEvents.Init, [esi].pChartSink

            ICall [esi].pIChart::_DMSChart.QueryInterface, offset IID_IConnectionPointContainer, \
                                                           addr pICPC
            ICall pICPC::IConnectionPointContainer.FindConnectionPoint, offset IID__DMSChartEvents,\
                                                                        addr [esi].pIEventsCP
            ICall [esi].pIEventsCP::IConnectionPoint.Advise, /Pointer, /Pointer
                                                        ;addr [esi].IChartEvents, addr [esi].dCookie
            ICall pICPC::IConnectionPointContainer.Release

            ;We also need an IOleObject interface
            ICall [esi].pIChart::IUnknown.QueryInterface, offset IID_IOleObject, \
                                                          addr [esi].pIOleObject
            mov eax, OBJ_OK
          .else
            OCall esi.ErrorReport, NULL, MSC_INIT_FAILED
          .endif
        .else
          OCall esi.ErrorReport, NULL, MSC_INIT_FAILED
        .endif
      .else
        OCall esi.ErrorReport, NULL, MSC_INIT_FAILED
      .endif
    .else
      OCall esi.ErrorReport, NULL, MSC_INIT_FAILED
    .endif
MethodEnd


; ==================================================================================================
;     IMSChartEvents implementation
; ==================================================================================================

; 
; Method:    IMSChartEvents.Init
; Purpose:   Initializes the IDispatch interface object.
; Arguments: Arg1: -> Owner object.
; Return:    Nothing.

Method IMSChartEvents.Init, uses esi, pOwner:Pointer
    local pITypeLib:Pointer

    ;DbgText "IMSChartEvents.Init"
    SetObject esi
    TCall esi::IUnknown.Init, pOwner
    mov [esi].pDispInterface, esi
    invoke LoadRegTypeLib, offset TLBID_MSChart20Lib, \
                           _MajorVer_MSChart20Lib, _MinorVer_MSChart20Lib, \
                           LOCALE_USER_DEFAULT, addr pITypeLib
    .if SUCCEEDED(eax)
      ICall pITypeLib::ITypeLib.GetTypeInfoOfGuid, offset IID__DMSChartEvents, addr [esi].pITypeInfo
      if DEBUGGING eq TRUE
        .if FAILED(eax)
          DbgComError eax
        .endif
      endif
      ICall pITypeLib::ITypeLib.Release

    if DEBUGGING eq TRUE
    .else
      DbgComError eax
    endif

    .endif
MethodEnd

; 
; Method:    IMSChartEvents.DispatchInvoke
; Purpose:   Implements the Invoke method.
; Arguments: Arg1: Method Member ID.
;            Arg2: -> IID_NULL
;            Arg3: Locale context in which to interpret the names.
;            Arg4: Flags (DISPATCH_METHOD, DISPATCH_PROPERTYGET, DISPATCH_PROPERTYPUT,
;                    DISPATCH_PROPERTYPUTREF).
;            Arg5: -> Array of arguments DispParams.
;            Arg6: -> Result.
;            Arg7: -> Exception Info.
;            Arg8: -> Index of the argument that produces the error.
; Return:    HRESULT.

Method IMSChartEvents.DispatchInvoke, uses ebx esi, dMethodID:dword, pIID:Pointer, dLCID:dword, \
                                           wFlags:word, pParams:LPDISPPARAMS, pResult:Pointer, \
                                           pExcepInfo:Pointer, pArgErrIdx:Pointer
    ;DbgText "IMSChartEvents.Invoke"
    SetObject esi
    ;Check for a TypeInfo pointer!
    xor eax, eax
    .if [esi].pITypeInfo == NULL
      mov eax, DISP_E_MEMBERNOTFOUND
    .else
      mov edx, Pointer ptr [esi]                        ;edx -> Dual Method Table
      mov ebx, [edx - 4]
      mov ecx, [ebx]                                    ;Number of events in structure
      add ebx, 04h                                      ;-> Events structure
      or ecx, ecx
      .while !Zero?
        mov eax, dword ptr [ebx]                        ;Recover message ID
        cmp eax, dMethodID
        je @@Found                                      ;Message ID found!
        add ebx, 8                                      ;Goto next event ID
        dec ecx
      .endw
      mov eax, DISP_E_MEMBERNOTFOUND
      ExitMethod
@@Found:
      mov ecx, [ebx + 4]                                ;Method offset
      .if sdword ptr ecx >= 0                           ;if < 0 => virtual method, else dynamic
        mov edx, esi
      .endif
      add edx, ecx                                      ;Add method offset
      mov eax, pParams
      mov ecx, [eax].DISPPARAMS.cArgs
      mov ebx, [eax].DISPPARAMS.rgvarg
      .while ecx != 0
        mov ax, [ebx].VARIANT.vt
        .if (ax & VT_BYREF)
          push [ebx].VARIANT.byRef
        .elseif eax == VT_VARIANT
          push [ebx + 12]
          push [ebx + 8]
          push [ebx + 4]
          push [ebx]
        .elseif (ax == VT_R8 || ax == VT_DATE || ax == VT_CY || ax == VT_FILETIME)
          push [ebx + 12]
          push [ebx + 8]
        .else
          push [ebx].VARIANT.lVal
        .endif
        add ebx, sizeof VARIANT
        dec ecx
      .endw
      push esi
      call Pointer ptr [edx]                            ;Invoke event handler
      .if pResult != NULL
        mov ebx, pResult
        mov [ebx].VARIANT.lVal, eax
      .endif
    .endif
MethodEnd

; 
; Method:    IMSChartEvents.OLEStartDrag
; Purpose:   MSChart event handler.
; Arguments:
; Return:    HRESULT.

Method IMSChartEvents.OLEStartDrag, NOFRAME, pDataObject:ptr ptr DataObject, \
                                    pAllowedEffects:ptr sdword
    DbgText "IMSChartEvents.OLEStartDrag"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.OLEGiveFeedback
; Purpose:   MSChart event handler.
; Arguments:
; Return:    HRESULT.

Method IMSChartEvents.OLEGiveFeedback, NOFRAME, pEffect:ptr sdword, pDefaultCursors:ptr BOOL
    DbgText "IMSChartEvents.OLEGiveFeedback"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.OLESetData
; Purpose:   MSChart event handler.
; Arguments:
; Return:    HRESULT.

Method IMSChartEvents.OLESetData, NOFRAME, pDataObject:ptr ptr DataObject, pDataFormat:ptr sword
    DbgText "IMSChartEvents.OLESetData"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.OLECompleteDrag
; Purpose:   MSChart event handler.
; Arguments:
; Return:    HRESULT.

Method IMSChartEvents.OLECompleteDrag, NOFRAME, pEffect:ptr sdword
    DbgText "IMSChartEvents.OLECompleteDrag"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.OLEDragOver
; Purpose:   MSChart event handler.
; Arguments:
; Return:    HRESULT.

Method IMSChartEvents.OLEDragOver, NOFRAME, pDataObject:ptr ptr DataObject, pEffect:ptr sdword, \
                                   pButton:ptr sword, pShift:ptr sword, \
                                   pX:ptr real4, pY:ptr real4, pState:ptr sword
    DbgText "IMSChartEvents.OLEDragOver"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.OLEDragDrop
; Purpose:   MSChart event handler.
; Arguments:
; Return:    HRESULT.

Method IMSChartEvents.OLEDragDrop, NOFRAME, pDataObject:ptr ptr DataObject, pEffect:ptr sdword, \
                                   pButton:ptr sword, pShift:ptr sword, \
                                   pX:ptr real4, pY:ptr real4
    DbgText "IMSChartEvents.OLEDragDrop"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.ChartSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.ChartSelected, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.ChartSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.TitleSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.TitleSelected, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.TitleSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.FootnoteSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.FootnoteSelected, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.FootnoteSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.LegendSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.LegendSelected, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.LegendSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PlotSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.PlotSelected, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.PlotSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.AxisSelected, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                    pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.AxisSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisLabelSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Labelset Index.
;            Arg4: [in] -> Label Index.
;            Arg5: [in] -> Mouse flags.
;            Arg6: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.AxisLabelSelected, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                         pLabelsetIndex:ptr sword, pLabelIndex:ptr sword, \
                                         pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.AxisLabelSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisTitleSelected
; Purpose:   MSChart event handler.
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.AxisTitleSelected, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                         pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.AxisTitleSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PointSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Data Point.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.PointSelected, NOFRAME, pSeries:ptr sword, pDataPoint:ptr sword, \
                                     pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.PointSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PointLabelSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Data Point.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.PointLabelSelected, NOFRAME, pSeries:ptr sword, pDataPoint:ptr sword, \
                                          pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.PointLabelSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.SeriesSelected
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Mouse flags.
;            Arg3: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.SeriesSelected, NOFRAME, pSeries:ptr sword, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.SeriesSelected"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.ChartActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.ChartActivated, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.ChartActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.TitleActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.TitleActivated, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.TitleActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.FootnoteActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.FootnoteActivated, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.FootnoteActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.LegendActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.LegendActivated, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.LegendActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PlotActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Mouse flags.
;            Arg2: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.PlotActivated, NOFRAME, pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.PlotActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.AxisActivated, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                     pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.AxisActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisLabelActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Labelset Index.
;            Arg4: [in] -> Label Index.
;            Arg5: [in] -> Mouse flags.
;            Arg6: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.AxisLabelActivated, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                          pLabelsetIndex:ptr sword, pLabelIndex:ptr sword, \
                                          pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.AxisLabelActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisTitleActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.AxisTitleActivated, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                          pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.AxisTitleActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PointActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Data Point.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.PointActivated, NOFRAME, pSeries:ptr sword, pDataPoint:ptr sword, \
                                      pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.PointActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PointLabelActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Data Point.
;            Arg3: [in] -> Mouse flags.
;            Arg4: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.PointLabelActivated, NOFRAME, pSeries:ptr sword, pDataPoint:ptr sword, \
                                           pMouseFlags:ptr sword, pCancel:ptr sword
    DbgText "IMSChartEvents.PointLabelActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.SeriesActivated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Mouse flags.
;            Arg3: [out] -> Cancel flag.
; Return:    HRESULT.

Method IMSChartEvents.SeriesActivated, NOFRAME, pSeries:ptr sword, pMouseFlags:ptr sword, \
                                       pCancel:ptr sword
    DbgText "IMSChartEvents.SeriesActivated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.AxisUpdated, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                   pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.AxisUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisLabelUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Labelset Index.
;            Arg4: [in] -> Label Index.
;            Arg5: [in] -> Update flags.
; Return:    HRESULT.

Method IMSChartEvents.AxisLabelUpdated, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                        pLabelsetIndex:ptr sword, pLabelIndex:ptr sword, \
                                        pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.AxisLabelUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.AxisTitleUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Axis ID.
;            Arg2: [in] -> Axis Index.
;            Arg3: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.AxisTitleUpdated, NOFRAME, pAxisID:ptr sword, pAxisIndex:ptr sword, \
                                        pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.AxisTitleUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.ChartUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.ChartUpdated, NOFRAME, pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.ChartUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.FootnoteUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.FootnoteUpdated, NOFRAME, pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.FootnoteUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.LegendUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.LegendUpdated, NOFRAME, pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.LegendUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PlotUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.PlotUpdated, NOFRAME, pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.PlotUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PointUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Data Point.
;            Arg3: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.PointUpdated, NOFRAME, pSeries:ptr sword, pDataPoint:ptr sword, \
                                    pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.PointUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.PointLabelUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Data Point.
;            Arg3: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.PointLabelUpdated, NOFRAME, pSeries:ptr sword, pDataPoint:ptr sword, \
                                         pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.PointLabelUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.SeriesUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Series.
;            Arg2: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.SeriesUpdated, NOFRAME, pSeries:ptr sword, pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.SeriesUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.TitleUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.TitleUpdated, NOFRAME, pUpdateFlags:ptr sword
    DbgText "IMSChartEvents.TitleUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.DataUpdated
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Row.
;            Arg2: [in] -> Column.
;            Arg3: [in] -> Label Row.
;            Arg4: [in] -> Label Column.
;            Arg5: [in] -> Labelset Index.
;            Arg6: [in] -> Update Flags.
; Return:    HRESULT.

Method IMSChartEvents.DataUpdated, NOFRAME, pRow:ptr sword, pColumn:ptr sword, pLabelRow:ptr sword, \
                                   pLabelColumn:ptr sword, pLabelsetIndex:ptr sword, \
                                   pUdateFlags:ptr sword
    DbgText "IMSChartEvents.DataUpdated"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.DonePainting
; Purpose:   MSChart event handler.
; Arguments: None.
; Return:    HRESULT.

Method IMSChartEvents.DonePainting
    DbgText "IMSChartEvents.DonePainting"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.Click
; Purpose:   MSChart event handler.
; Arguments: None.
; Return:    HRESULT.

Method IMSChartEvents.Click
    DbgText "IMSChartEvents.Click"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.DblClick
; Purpose:   MSChart event handler.
; Arguments: None.
; Return:    HRESULT.

Method IMSChartEvents.DblClick
    DbgText "IMSChartEvents.DblClick"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.KeyDown
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Key Code.
;            Arg2: [in] -> Shift Flags.
; Return:    HRESULT.

Method IMSChartEvents.KeyDown, NOFRAME, pKeyCode:ptr sword, pShift:sword
    DbgText "IMSChartEvents.KeyDown"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.KeyPress
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Key Ascii.
; Return:    HRESULT.

Method IMSChartEvents.KeyPress, NOFRAME, pKeyAscii:ptr sword
    DbgText "IMSChartEvents.KeyPress"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.KeyUp
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> Key Code.
;            Arg2: [in] -> Shift Flags.
; Return:    HRESULT.

Method IMSChartEvents.KeyUp, NOFRAME, pKeyCode:ptr sword, pShift:sword
    DbgText "IMSChartEvents.KeyUp"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.MouseDown
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> pButton.
;            Arg2: [in] -> Shift Flags.
;            Arg3: [in] -> x Position.
;            Arg4: [in] -> y Position.
; Return:    HRESULT.

Method IMSChartEvents.MouseDown, NOFRAME, pButton:sword, pShift:sword, r4XPos:OLE_XPOS_PIXELS, \
                                 r4YPos:OLE_YPOS_PIXELS
    DbgText "IMSChartEvents.MouseDown"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.MouseMove
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> pButton.
;            Arg2: [in] -> Shift Flags.
;            Arg3: [in] -> x Position.
;            Arg4: [in] -> y Position.
; Return:    HRESULT.

Method IMSChartEvents.MouseMove, NOFRAME, pButton:sword, pShift:sword, r4XPos:OLE_XPOS_PIXELS, \
                                 r4YPos:OLE_YPOS_PIXELS
    DbgText "IMSChartEvents.MouseMove"
    mov eax, S_OK
MethodEnd

; 
; Method:    IMSChartEvents.MouseUp
; Purpose:   MSChart event handler.
; Arguments: Arg1: [in] -> pButton.
;            Arg2: [in] -> Shift Flags.
;            Arg3: [in] -> x Position.
;            Arg4: [in] -> y Position.
; Return:    HRESULT.

Method IMSChartEvents.MouseUp, NOFRAME, pButton:sword, pShift:sword, r4XPos:OLE_XPOS_PIXELS, \
                               r4YPos:OLE_YPOS_PIXELS
    DbgText "IMSChartEvents.MouseUp"
    mov eax, S_OK
MethodEnd


endif
