; ==================================================================================================
; Title:   MSChartDemo.asm
; Author:  G. Friedrich  @ May 2009
; Version: 1.0.0
; Purpose: MSChartDemo for ObjAsm32.
; ==================================================================================================


%include @Environ(OA32_PATH)\\Code\\Macros\\Model.inc       ;Include & initialize standard modules
SysSetup OOP_WINDOWS;, DEBUG(WND, RESGUARD)                 ;Loads OOP files and OS related objects

include MSChartDemo_Globals.inc                             ;Includes application globals
IncludeAPIs advapi32, ole32, oleaut32                       ;Includes these APIs
IncludeAPIs HtmlHelp

% include &MacPath&fMath.inc
% include &MacPath&UStrings.inc                             ;UNICODE string support
% include &MacPath&BStrings.inc                             ;BSTR support
% include &COMPath&COM.inc                                  ;COM basic support
% include &COMPath&OAIDL.inc
% include &COMPath&OleCtl.inc
% include &COMPath&COM_Dispatch.inc
% include &COMPath&COM_Interfaces.inc                       ;COM common interfaces
% include &COMPath&COM_Dispatch.inc                         ;Dispatch definitions and macros
% include &COMPath&COM_Dispatch.asm                         ;Dispatch procedures

.const                                                      ;Global GUIDs
DefGUID IID_NULL, %sGUID_NULL
DefGUID IID_IUnknown, %sIID_IUnknown

;Load or build the following objects
LoadObjects Collection, DataCollection
LoadObjects Dialog, DialogModal, DialogAbout
LoadObjects WinApp, SdiApp
MakeObjects COMPrimers, IDispatch

include MSChart20Lib.inc

.const
DefGUID IID__DMSChart, %sIID__DMSChart
DefGUID IID__DMSChartEvents, %sIID__DMSChartEvents
DefGUID IID_IConnectionPointContainer, %sIID_IConnectionPointContainer
DefGUID IID_IConnectionPoint, %sIID_IConnectionPoint
DefGUID IID_IEnumConnections, %sIID_IEnumConnections
DefGUID IID_IEnumConnectionPoints, %sIID_IEnumConnectionPoints
DefGUID IID_IDispatch, %sIID_IDispatch
DefGUID IID_IOleObject, %sIID_IOleObject

DefGUID TLBID_MSChart20Lib, %sTLBID_MSChart20Lib


.code
MakeObjects .\MSChart

include MSChartDemo.inc                                     ;Includes MSChartDemoApp object

start:                                                      ;Program entry point
    ;***** ObjAsm32 initialization *****
    SysInit

    ;***** OLE / COM initialization *****
    invoke CoInitialize, 0

    ResGuard_Start                                          ;Activates ResGuard
    OCall TPL_MSChartDemoApp::MSChartDemoApp.Init           ;Initializes the object data
    OCall TPL_MSChartDemoApp::MSChartDemoApp.Run            ;Executes the application
    OCall TPL_MSChartDemoApp::MSChartDemoApp.Done           ;Finalizes it
    ResGuard_Show                                           ;Shows ResGuard results

    ;***** OLE / COM cleanup *****
    invoke CoUninitialize

    ;***** ObjAsm32 cleanup *****
    SysDone

    invoke ExitProcess, 0                                   ;Exits program returning 0 to the OS
end start                                                   ;Code end and defines prg entry point
